diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerClick.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerClick.java
index 6fb4232e6..3afb71bb0 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerClick.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerClick.java
@@ -1,58 +1,72 @@
 package net.minecraft.core.net.packet;
 
+import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.handler.PacketHandler;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.*;
 
 public class PacketContainerClick extends Packet {
 
+	public int window_Id;
+	public InventoryAction action;
+	public int[] args;
+	public int stateId;
+	public Int2ObjectMap<ItemStack> changedSlots;
+	public ItemStack carriedItem;
+
 	public PacketContainerClick() {
 	}
 
-	public PacketContainerClick(int windowId, InventoryAction action, int[] args, ItemStack itemstack, short actionId) {
+	public PacketContainerClick(int windowId, InventoryAction action, int[] args, int stateId, Int2ObjectMap<ItemStack> changedSlots, ItemStack carriedItem) {
 		this.window_Id = windowId;
 		this.action = action;
 		this.args = args;
-		this.itemStack = itemstack;
-		this.actionId = actionId;
+		this.stateId = stateId;
+		this.changedSlots = changedSlots;
+		this.carriedItem = carriedItem;
 	}
 
 	@Override
-	public void handlePacket(PacketHandler packetHandler) {
+	public void handlePacket(@NotNull PacketHandler packetHandler) {
 		packetHandler.handleContainerClick(this);
 	}
 
 	@Override
-	public void read(DataInputStream dis) throws IOException {
+	public void read(@NotNull DataInputStream dis) throws IOException {
 		window_Id = dis.readByte();
 		action = InventoryAction.get(dis.readByte());
-		
+
 		int size = dis.readByte();
 		args = new int[size];
 		for(int i=0; i < size; i++) {
 			args[i] = dis.read();
 		}
-		
-		actionId = dis.readShort();
-		short word0 = dis.readShort();
-		if(word0 >= 0) {
-			byte byte0 = dis.readByte();
-			short word1 = dis.readShort();
-			itemStack = new ItemStack(word0, byte0, word1);
-		} else {
-			itemStack = null;
+
+		stateId = dis.readInt();
+
+		int changedCount = dis.readShort();
+		changedSlots = new Int2ObjectArrayMap<>(changedCount);
+		for(int i=0; i < changedCount; i++) {
+			int slot = dis.readShort();
+			changedSlots.put(slot, readStack(dis));
 		}
+
+		carriedItem = readStack(dis);
 	}
 
 	@Override
-	public void write(DataOutputStream dos)
+	public void write(@NotNull DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(window_Id);
         dos.writeByte(action.getId());
-        
+
         if(args != null) {
         	if(args.length > 255) {
         		System.err.println("Too many args!");
@@ -68,27 +82,46 @@ public class PacketContainerClick extends Packet {
         }else {
         	dos.write(0);
         }
-        
-        dos.writeShort(actionId);
-        if(itemStack == null)
-        {
-            dos.writeShort(-1);
-        } else
-        {
-            dos.writeShort(itemStack.itemID);
-            dos.writeByte(itemStack.stackSize);
-            dos.writeShort(itemStack.getMetadata());
-        }
-    }
+
+		dos.writeInt(stateId);
+
+		if(changedSlots == null) {
+			dos.writeShort(0);
+		} else {
+			dos.writeShort(changedSlots.size());
+			for(Int2ObjectMap.Entry<ItemStack> entry : changedSlots.int2ObjectEntrySet()) {
+				dos.writeShort(entry.getIntKey());
+				writeStack(dos, entry.getValue());
+			}
+		}
+
+		writeStack(dos, carriedItem);
+	}
+
+	private static @Nullable ItemStack readStack(@NotNull DataInputStream dis) throws IOException {
+		short itemId = dis.readShort();
+		if(itemId >= 0) {
+			byte size = dis.readByte();
+			short meta = dis.readShort();
+			CompoundTag tag = readCompressedCompoundTag(dis);
+			return new ItemStack(itemId, size, meta, tag);
+		}
+		return null;
+	}
+
+	private static void writeStack(DataOutputStream dos, ItemStack stack) throws IOException {
+		if(stack == null) {
+			dos.writeShort(-1);
+		} else {
+			dos.writeShort(stack.itemID);
+			dos.writeByte(stack.stackSize);
+			dos.writeShort(stack.getMetadata());
+			writeCompressedCompoundTag(stack.getData(), dos);
+		}
+	}
 
 	@Override
 	public int getEstimatedSize() {
-		return 7 + (args != null ? args.length : 0);
+		return 11 + (args != null ? args.length : 0) + (changedSlots != null ? changedSlots.size() * 7 : 0);
 	}
-
-	public int window_Id;
-	public InventoryAction action;
-	public int[] args;
-	public short actionId;
-	public ItemStack itemStack;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetContent.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetContent.java
index 29378c678..533f27578 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetContent.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetContent.java
@@ -3,6 +3,8 @@ package net.minecraft.core.net.packet;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.handler.PacketHandler;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.*;
 import java.util.List;
@@ -10,16 +12,20 @@ import java.util.List;
 public class PacketContainerSetContent extends Packet
 {
     public int windowId;
+    public int stateId;
     public ItemStack[] stackList;
+    public ItemStack carriedItem;
 
 
     public PacketContainerSetContent()
     {
     }
 
-    public PacketContainerSetContent(int i, List<ItemStack> list)
+    public PacketContainerSetContent(int windowId, int stateId, List<ItemStack> list, ItemStack carriedItem)
     {
-        windowId = i;
+        this.windowId = windowId;
+        this.stateId = stateId;
+        this.carriedItem = carriedItem != null ? carriedItem.copy() : null;
         stackList = new ItemStack[list.size()];
         for(int j = 0; j < stackList.length; j++)
         {
@@ -30,54 +36,60 @@ public class PacketContainerSetContent extends Packet
     }
 
     @Override
-	public void read(DataInputStream dis)
+	public void read(@NotNull DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
+        stateId = dis.readInt();
+        carriedItem = readStack(dis);
         short listSize = dis.readShort();
         stackList = new ItemStack[listSize];
         for(int i = 0; i < listSize; i++)
         {
-            short itemId = dis.readShort();
-            if(itemId >= 0)
-            {
-                byte size = dis.readByte();
-                short meta = dis.readShort();
-                CompoundTag tag = readCompressedCompoundTag(dis);
-                ItemStack s = new ItemStack(itemId, size, meta, tag);
-                stackList[i] = s;
-//                System.out.printf("Received|| Name:%s, ID:%s, CustomName:%s, Tag:%s\n", s.getItemKey(), s.itemID, s.getCustomName(), s.getData());
-            }
+            stackList[i] = readStack(dis);
         }
 
     }
 
     @Override
-	public void write(DataOutputStream dos)
+	public void write(@NotNull DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
+        dos.writeInt(stateId);
+        writeStack(dos, carriedItem);
         dos.writeShort(stackList.length);
         for(int i = 0; i < stackList.length; i++)
         {
-            if(stackList[i] == null)
-            {
-                dos.writeShort(-1);
-            } else
-            {
-                dos.writeShort((short) stackList[i].itemID);
-                dos.writeByte((byte) stackList[i].stackSize);
-                dos.writeShort((short) stackList[i].getMetadata());
-                writeCompressedCompoundTag(stackList[i].getData(), dos);
-//                ItemStack s = stackList[i];
-//                System.out.printf("Sent|| Name:%s, ID:%s, CustomName:%s, Tag:%s\n", s.getItemKey(), s.itemID, s.getCustomName(), s.getData());
-            }
+            writeStack(dos, stackList[i]);
         }
 
     }
 
+    private static @Nullable ItemStack readStack(@NotNull DataInputStream dis) throws IOException {
+        short itemId = dis.readShort();
+        if(itemId >= 0) {
+            byte size = dis.readByte();
+            short meta = dis.readShort();
+            CompoundTag tag = readCompressedCompoundTag(dis);
+            return new ItemStack(itemId, size, meta, tag);
+        }
+        return null;
+    }
+
+    private static void writeStack(DataOutputStream dos, ItemStack stack) throws IOException {
+        if(stack == null) {
+            dos.writeShort(-1);
+        } else {
+            dos.writeShort((short) stack.itemID);
+            dos.writeByte((byte) stack.stackSize);
+            dos.writeShort((short) stack.getMetadata());
+            writeCompressedCompoundTag(stack.getData(), dos);
+        }
+    }
+
     @Override
-	public void handlePacket(PacketHandler packetHandler)
+	public void handlePacket(@NotNull PacketHandler packetHandler)
     {
         packetHandler.handleContainerSetContent(this);
     }
@@ -85,6 +97,6 @@ public class PacketContainerSetContent extends Packet
     @Override
 	public int getEstimatedSize()
     {
-        return 3 + stackList.length * 5;
+        return 12 + stackList.length * 5;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetSlot.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetSlot.java
index 4d879790a..99bf584c3 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetSlot.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketContainerSetSlot.java
@@ -3,6 +3,7 @@ package net.minecraft.core.net.packet;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.net.handler.PacketHandler;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
@@ -14,23 +15,25 @@ public class PacketContainerSetSlot extends Packet
     }
 
     @Override
-	public void handlePacket(PacketHandler packetHandler)
+	public void handlePacket(@NotNull PacketHandler packetHandler)
     {
         packetHandler.handleContainerSetSlot(this);
     }
-    
-    public PacketContainerSetSlot(int i, int j, ItemStack itemstack)
+
+    public PacketContainerSetSlot(int windowId, int stateId, int slot, ItemStack itemstack)
     {
-        windowId = i;
-        itemSlot = j;
-        myItemStack = itemstack != null ? itemstack.copy() : itemstack;
+        this.windowId = windowId;
+        this.stateId = stateId;
+        this.itemSlot = slot;
+        this.myItemStack = itemstack != null ? itemstack.copy() : itemstack;
     }
 
     @Override
-	public void read(DataInputStream dis)
+	public void read(@NotNull DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
+        stateId = dis.readInt();
         itemSlot = dis.readShort();
         short word0 = dis.readShort();
         if(word0 >= 0)
@@ -46,10 +49,11 @@ public class PacketContainerSetSlot extends Packet
     }
 
     @Override
-	public void write(DataOutputStream dos)
+	public void write(@NotNull DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
+        dos.writeInt(stateId);
         dos.writeShort(itemSlot);
         if(myItemStack == null)
         {
@@ -66,10 +70,11 @@ public class PacketContainerSetSlot extends Packet
     @Override
 	public int getEstimatedSize()
     {
-        return 8;
+        return 12;
     }
 
     public int windowId;
+    public int stateId;
     public int itemSlot;
     public ItemStack myItemStack;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketVehicleControl.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketVehicleControl.java
new file mode 100644
index 000000000..de104e8a0
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketVehicleControl.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.handler.PacketHandler;
+import org.jetbrains.annotations.NotNull;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+/**
+ * Sent by the client driving a vehicle. The server applies it, and may send it to nearby players.
+ * <p>
+ * The meaning of the three values changes based on the vehicle:
+ * <li>{@code EntityBoat} treats xd/yd/zd as velocity</li>
+ * <li>{@code MobPig} treats xd/yd/zd as the pig's absolute position</li>
+ */
+public class PacketVehicleControl extends Packet {
+    public int entityId;
+    public double targetXD;
+    public double targetYD;
+    public double targetZD;
+    public float targetYRot;
+    public float fallDistance;
+
+    public PacketVehicleControl() {
+    }
+
+    public PacketVehicleControl(@NotNull Entity entity) {
+        this(entity.id, entity.xd, entity.yd, entity.zd, entity.yRot, 0f);
+    }
+
+    public PacketVehicleControl(int entityId, double targetXD, double targetYD, double targetZD, float targetYRot, float fallDistance) {
+        this.entityId = entityId;
+        this.targetXD = targetXD;
+        this.targetYD = targetYD;
+        this.targetZD = targetZD;
+        this.targetYRot = targetYRot;
+        this.fallDistance = fallDistance;
+    }
+
+    @Override
+    public void read(@NotNull DataInputStream dis) throws IOException {
+        entityId = dis.readInt();
+        targetXD = dis.readDouble();
+        targetYD = dis.readDouble();
+        targetZD = dis.readDouble();
+        targetYRot = dis.readFloat();
+        fallDistance = dis.readFloat();
+    }
+
+    @Override
+    public void write(@NotNull DataOutputStream dos) throws IOException {
+        dos.writeInt(entityId);
+        dos.writeDouble(targetXD);
+        dos.writeDouble(targetYD);
+        dos.writeDouble(targetZD);
+        dos.writeFloat(targetYRot);
+        dos.writeFloat(fallDistance);
+    }
+
+    @Override
+    public void handlePacket(@NotNull PacketHandler packetHandler) {
+        packetHandler.handleVehicleControl(this);
+    }
+
+    @Override
+    public int getEstimatedSize() {
+        return 4 + 8 * 3 + 4 + 4;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index f558bd76f..7f02e44c3 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -31,18 +31,17 @@ public abstract class MenuAbstract
 	public List<ItemStack> lastSlots;
 	public List<Slot> slots;
 	public int containerId;
-	private short changeUid;
+	public int stateId;
+	private boolean suppressRemoteUpdates;
 	protected List<ContainerListener> containerListeners;
-	private final Set<Player> unSynchedPlayers;
 
 	public MenuAbstract()
 	{
 		lastSlots = new ArrayList<>();
 		slots = new ArrayList<>();
 		containerId = 0;
-		changeUid = 0;
+		stateId = 0;
 		containerListeners = new ArrayList<>();
-		unSynchedPlayers = new HashSet<>();
 	}
 
 	protected final void addSlot(Slot slot)
@@ -62,6 +61,7 @@ public abstract class MenuAbstract
 		{
 			containerListeners.add(containerListener);
 			containerListener.updateCraftingInventory(this, getSlotStackList());
+			resetRemoteSlots();
 			broadcastChanges();
 		}
 	}
@@ -79,6 +79,11 @@ public abstract class MenuAbstract
 
 	public void broadcastChanges()
 	{
+		if(suppressRemoteUpdates)
+		{
+			return;
+		}
+		boolean bumpedState = false;
 		for(int i = 0; i < slots.size(); i++)
 		{
 
@@ -88,6 +93,11 @@ public abstract class MenuAbstract
 			{
 				continue;
 			}
+			if(!bumpedState)
+			{
+				incrementStateId();
+				bumpedState = true;
+			}
 			itemstack1 = itemstack != null ? itemstack.copy() : null;
 			lastSlots.set(i, itemstack1);
 			for (ContainerListener crafter : containerListeners) {
@@ -98,6 +108,36 @@ public abstract class MenuAbstract
 
 	}
 
+	public int getStateId()
+	{
+		return stateId;
+	}
+
+	public int incrementStateId()
+	{
+		this.stateId++;
+		return this.stateId;
+	}
+
+	public void setRemoteSlot(int index, ItemStack stack)
+	{
+		lastSlots.set(index, stack != null ? stack.copy() : null);
+	}
+
+	public void resetRemoteSlots()
+	{
+		for(int i = 0; i < slots.size(); i++)
+		{
+			ItemStack stack = slots.get(i).getItemStack();
+			lastSlots.set(i, stack != null ? stack.copy() : null);
+		}
+	}
+
+	public void setRemoteUpdatesSuppressed(boolean suppressed)
+	{
+		this.suppressRemoteUpdates = suppressed;
+	}
+
 	/**
 	 * @param container ContainerInventory
 	 * @param index integer index of slot in container
@@ -801,22 +841,6 @@ public abstract class MenuAbstract
 		broadcastChanges();
 	}
 
-	public boolean isSynched(Player entityplayer)
-	{
-		return !unSynchedPlayers.contains(entityplayer);
-	}
-
-	public void setSynched(Player entityplayer, boolean flag)
-	{
-		if(flag)
-		{
-			unSynchedPlayers.remove(entityplayer);
-		} else
-		{
-			unSynchedPlayers.add(entityplayer);
-		}
-	}
-
 	public void setItem(int i, ItemStack itemstack)
 	{
 		getSlot(i).set(itemstack);
@@ -835,20 +859,6 @@ public abstract class MenuAbstract
 	{
 	}
 
-	public short backup(ContainerInventory inventoryplayer)
-	{
-		changeUid++;
-		return changeUid;
-	}
-
-	public void deleteBackup(short word0)
-	{
-	}
-
-	public void rollbackToBackup(short word0)
-	{
-	}
-
 	public abstract boolean stillValid(@NotNull Player player);
 
 	/**
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index d28f2b8f8..d91a68214 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -155,6 +155,11 @@ public class MenuInventoryCreative extends MenuInventory
 		inventory.player.updateCreativeInventory(page, searchText);
 	}
 
+	public void broadcastInventoryStatus()
+	{
+		inventory.player.updateCreativeInventory(page, searchText);
+	}
+
 	public String getSearchText(){
 		return searchText;
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java b/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
index 6f653673f..236a8860e 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
@@ -9,6 +9,9 @@ import java.util.ArrayList;
 import java.util.EnumSet;
 import java.util.List;
 
+import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
+
 public class BoundingVolume
 {
     private enum Line
@@ -79,6 +82,46 @@ public class BoundingVolume
         return volume;
     }
 
+    public static @NotNull BoundingVolume bakeFromBlockSpaceAabbs(AABBdc @NotNull ... boxes)
+    {
+        BoundingVolume vol = BoundingVolume.newEmptyVolume();
+        if (boxes.length == 0)
+        {
+            vol.bake();
+            return vol;
+        }
+        double inv = 1.0 / SIZE;
+        for (int iy = 0; iy < SIZE; iy++)
+        {
+            for (int iz = 0; iz < SIZE; iz++)
+            {
+                for (int ix = 0; ix < SIZE; ix++)
+                {
+                    double x = (ix + 0.5) * inv;
+                    double y = (iy + 0.5) * inv;
+                    double z = (iz + 0.5) * inv;
+                    for (AABBdc box : boxes)
+                    {
+                        if (pointInsideBlockSpaceAabb(box, x, y, z))
+                        {
+                            vol.fillVolume(ix, iy, iz, ix, iy, iz);
+                            break;
+                        }
+                    }
+                }
+            }
+        }
+        vol.bake();
+        return vol;
+    }
+
+    private static boolean pointInsideBlockSpaceAabb(@NotNull AABBdc box, double x, double y, double z)
+    {
+        return x >= box.minX() && x <= box.maxX()
+                && y >= box.minY() && y <= box.maxY()
+                && z >= box.minZ() && z <= box.maxZ();
+    }
+
     private boolean isCarved(int x, int y, int z)
     {
         if (x < 0 || x >= SIZE) return true;
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index e892660e7..5f4aa2f35 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -3,7 +3,6 @@ package net.minecraft.core.world;
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.longs.LongOpenHashSet;
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
-import it.unimi.dsi.fastutil.objects.ObjectLinkedOpenHashSet;
 import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.Global;
 import net.minecraft.core.NextTickListEntry;
@@ -14,7 +13,6 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.current.wire.ConduitHandler;
 import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
@@ -49,7 +47,6 @@ import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.lighting.LightingEngine;
 import net.minecraft.core.world.lighting.LightingEngineLegacy;
-import net.minecraft.core.world.particle.ParticleEmitterRegistry;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
 import net.minecraft.core.world.pos.*;
@@ -120,14 +117,13 @@ public abstract class World implements MutableWorldSource {
     private final @NotNull List<@NotNull Entity> entityBuffer = new ObjectArrayList<>();
     private final @NotNull Set<@NotNull NextTickListEntry> immediatelyUpdatedPositions = new ObjectOpenHashSet<>();
 
-    public final ParticleEmitterRegistry particleEmitters = new ParticleEmitterRegistry();
-
     public final @NotNull Random rand = new Random();
     private final AABBd workingBox = new AABBd();
     public final @NotNull Dimension dimension;
     public final boolean isNewWorld;
 
     public boolean scheduledUpdatesAreImmediate = false;
+    public boolean isDecorating = false;
     public int skyDarken = 0;
     protected int updateLCG = new Random().nextInt();
     public int lightningFlicker = 0;
@@ -156,7 +152,6 @@ public abstract class World implements MutableWorldSource {
     private final @NotNull WeatherManager weatherManager;
     private final @NotNull CommandManager commandManager = new CommandManager(isServer);
     private final @NotNull WireHandler wireHandler = new WireHandler(this);
-    private final @NotNull ConduitHandler conduitHandler = new ConduitHandler(this);
     private final @NotNull LightingEngine lightingEngine = new LightingEngineLegacy(this);
 
     protected World(
@@ -314,10 +309,6 @@ public abstract class World implements MutableWorldSource {
         return this.wireHandler;
     }
 
-    public @NotNull ConduitHandler getConduitHandler() {
-        return this.conduitHandler;
-    }
-
     protected abstract @NotNull ChunkProvider createChunkProvider(@NotNull LevelStorage levelStorage); /* {
         final ChunkLoader chunkLoader = this.levelStorage.getChunkLoader(this.dimension);
         return accessor.createChunkProvider(this, chunkLoader);
@@ -586,8 +577,8 @@ public abstract class World implements MutableWorldSource {
 
         final @NotNull ChunkPos chunkPos = new ChunkPos(minX, minZ);
 
-        for (; chunkPos.x <= maxX; chunkPos.x++) {
-            for (; chunkPos.z <= maxZ; chunkPos.z++) {
+        for (chunkPos.x = minX; chunkPos.x <= maxX; chunkPos.x++) {
+            for (chunkPos.z = minZ; chunkPos.z <= maxZ; chunkPos.z++) {
                 if (!this.isChunkLoaded(chunkPos)) {
                     return false;
                 }
@@ -633,12 +624,20 @@ public abstract class World implements MutableWorldSource {
         return this.getChunk(new ChunkPos(x, z));
     }
 
+    private boolean notifyDecorationWrite(final @NotNull Chunk chunk, final @NotNull TilePosc tilePos, final boolean changed) {
+        if (changed && this.isDecorating && chunk.sentToClients) {
+            this.markBlockNeedsUpdate(tilePos);
+        }
+        return changed;
+    }
+
     @Override
     public boolean setBlockTypeData(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockIdData(new ChunkTilePos(tilePos), block.id(), data);
+            final Chunk chunk = this.getChunk(tilePos);
+            return this.notifyDecorationWrite(chunk, tilePos, chunk.setBlockIdData(new ChunkTilePos(tilePos), block.id(), data));
         }
     }
 
@@ -650,6 +649,7 @@ public abstract class World implements MutableWorldSource {
         final var prevBlock = c.getBlock(ctp);
         final var prevData = c.getBlockData(ctp);
         if (!c.setBlockIdDataRaw(ctp, block.id(), data)) return false;
+        this.notifyDecorationWrite(c, tilePos, true);
 
         this.replaceTileEntity(tilePos, entity);
         prevBlock.getLogic().onRemoved(this, tilePos, prevData);
@@ -671,7 +671,8 @@ public abstract class World implements MutableWorldSource {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockIdDataRaw(new ChunkTilePos(tilePos), block.id(), data);
+            final Chunk chunk = this.getChunk(tilePos);
+            return this.notifyDecorationWrite(chunk, tilePos, chunk.setBlockIdDataRaw(new ChunkTilePos(tilePos), block.id(), data));
         }
     }
 
@@ -689,7 +690,8 @@ public abstract class World implements MutableWorldSource {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockId(new ChunkTilePos(tilePos), block.id());
+            final Chunk chunk = this.getChunk(tilePos);
+            return this.notifyDecorationWrite(chunk, tilePos, chunk.setBlockId(new ChunkTilePos(tilePos), block.id()));
         }
     }
 
@@ -1637,20 +1639,21 @@ public abstract class World implements MutableWorldSource {
         }
 
         this.updatingTileEntities = true;
+        updateTileEntities();
+        this.updatingTileEntities = false;
+    }
+
+    protected void updateTileEntities() {
         for (int i = this.tileEntityList.size() - 1; i >= 0; i--) {
             final TileEntity tileEntity = this.tileEntityList.get(i);
-            if (!tileEntity.isInvalid() && this.isBlockLoaded(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z)) {
+            if (!tileEntity.isInvalid() && this.isBlockLoaded(tileEntity.tilePos)) {
                 tileEntity.tick();
             }
             if (tileEntity.isInvalid()) {
                 this.tileEntityList.remove(i);
-                final Chunk chunk = this.getChunkFromChunkCoords(Math.floorDiv(tileEntity.tilePos.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(tileEntity.tilePos.z, Chunk.CHUNK_SIZE_Z));
-                if (chunk != null) {
-                    chunk.removeTileEntity(tileEntity);
-                }
+                this.getChunk(tileEntity.tilePos).removeTileEntity(tileEntity);
             }
         }
-        this.updatingTileEntities = false;
     }
 
     public void addAllBlockEntities(final Collection<TileEntity> blockEntities) {
@@ -2550,6 +2553,7 @@ public abstract class World implements MutableWorldSource {
         if (this.isBlockNormalCube(tilePos)) direct_sig: {
             if (block == Blocks.BLOCK_REDSTONE) break direct_sig;
             if (block == Blocks.PUMPKIN_REDSTONE) break direct_sig;
+            if (block == Blocks.MATCHER) break direct_sig;
             if (block == Blocks.MATCHER_ACTIVE) break direct_sig;
             if (this.hasDirectSignal(tilePos)) return true;
         }
@@ -2997,9 +3001,9 @@ public abstract class World implements MutableWorldSource {
     }
 
     public @NotNull EntityItem dropItem(double x, double y, double z, final @NotNull ItemStack itemStack, double radius) {
-        x += this.rand.nextFloat() * radius;
-        y += this.rand.nextFloat() * radius;
-        z += this.rand.nextFloat() * radius;
+        x += 0.5 + (this.rand.nextDouble() - 0.5) * radius;
+        y += 0.5 + this.rand.nextDouble() * radius * 0.25;
+        z += 0.5 + (this.rand.nextDouble() - 0.5) * radius;
 
         final @NotNull EntityItem item = new EntityItem(this, x, y, z, itemStack);
         item.pickupDelay = 10;
